<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace App\Http\Base;

use App\Http\Controllers\Controller;
use App\Http\Models\AdministratormenuModel;
use Illuminate\Http\Request;
use Predis\Client;

class BaseController extends Controller
{

    public $data = [];
    protected $baseService = "";
    protected $service;

    public function __construct()
    {
        $this->baseService;
        $this->getSegments();
        $this->getCurrentRoute();
        $this->getTitle();
        $this->getShowSize();
        $this->getCurrentPrefix();
    }

    public function getSegments()
    {
        $tmpUrl = "";
        $segment = [];
        $segments = \Request::instance()->segments();
        for ($i = 0; $i < count($segments); $i++) {
            $tmpUrl = $tmpUrl . $segments[$i] . "/";
            $segment[$i]["url"] = $tmpUrl;
            $segment[$i]["name"] = ucfirst($segments[$i]);
        }
        $this->data["segments"] = $segment;
    }

    public function getCurrentRoute()
    {
        $this->data["currentRoute"] = \Request::instance()->route()->getPath();
    }

    public function getTitle()
    {
        $menu = new AdministratormenuModel();
        $menu = $menu->getQuery()->where("administratormenu.url", "=", $this->data["currentRoute"])->first();
        if ($menu)
            $this->data["title"] = ucfirst($menu->menuname);
        else
            $this->data["title"] = "";
    }

    public function getShowSize()
    {
        $this->data["sizeList"] = [10, 25, 50, 100];
    }

    public function getCurrentPrefix()
    {
        $this->data["currentPrefix"] = \Request::instance()->route()->getPrefix();
    }

    public function req()
    {
        $request = new Request();
        $request->route()->getPath();
    }

    public function responseOk($data)
    {
        return \response()->json($data);
    }

    public function sync()
    {
        if ($GLOBALS["env"]["APLICATION_TYPE"] != "HO") {
            if ($this->hasInternetConnection()) {
                $client = new Client();
                $client->publish("sync", true);
            }
        }
    }

    public function hasInternetConnection()
    {
        $is_conn = false;
        $connected = @fsockopen(preg_replace("(^https?://)", "", $GLOBALS["env"]["HEAD_OFFICE_URL"]), 80, $errno, $errstr, 10);
        if ($connected) {
            $is_conn = true; //action when connected
            fclose($connected);
        }
        return $is_conn;
    }

    public static function syncConsole()
    {
        if ($GLOBALS["env"]["APLICATION_TYPE"] != "HO") {
            if (BaseController::hasInternet()) {
                $client = new Client();
                $client->publish("sync", true);
            }
        }
    }

    public static function hasInternet()
    {
        $is_conn = false;
        $connected = @fsockopen(preg_replace("(^https?://)", "", $GLOBALS["env"]["HEAD_OFFICE_URL"]), 80, $errno, $errstr, 10);
        if ($connected) {
            $is_conn = true; //action when connected
            fclose($connected);
        }
        return $is_conn;
    }
}
